import { StyleType } from "./models/style.model";
import { styleFactory } from "./styles/style-factory";
export class ElementStyles {
    constructor(pageElement) {
        this.pageElement = pageElement;
        this.stylesMap = new Map();
    }
    init() {
        Object.values(StyleType).forEach(type => {
            const style = styleFactory(this.pageElement, type);
            const schemaStyles = this.pageElement.schema.styles?.[type];
            this.stylesMap.set(type, style);
            if (schemaStyles) {
                style.setStyleRule(schemaStyles);
            }
        });
    }
    get(type) {
        return this.stylesMap.get(type);
    }
}
//# sourceMappingURL=element-styles.js.map