import { v4 as uuidv4 } from 'uuid';
import { EventEmitter } from "../event-emitter";
export class PageBaseNode extends EventEmitter {
    constructor() {
        super();
    }
    createNode() {
        this.key = uuidv4();
        this.schema.key = this.key;
    }
    findElement(predicate) {
        return predicate(this) ? this : undefined;
    }
    ;
    destroy() {
        this.parentElement?.removeChild(this);
    }
    getSchema() {
        return this.schema;
    }
    removeChild(child) {
        this.children = this.children?.filter(el => el !== child);
        this.nativeElement.removeChild(child.hostElement || child.nativeElement);
        this.page.schemaChanged();
    }
    changeElementIndex(newIndex) {
        if (!this.parentElement) {
            return;
        }
        if (newIndex < 0 || newIndex > Number(this.parentElement?.children?.length)) {
            console.error('Invalid indices provided');
            return;
        }
        const parent = this.parentElement;
        const currentIndex = parent.children.findIndex(el => el === this);
        const targetPageNode = parent.children[newIndex];
        const targetElement = targetPageNode.hostElement;
        const currentElement = this.hostElement;
        parent.nativeElement.removeChild(currentElement);
        if (currentIndex > newIndex) {
            parent.nativeElement.insertBefore(currentElement, targetElement);
        }
        else {
            const nextSibling = targetElement.nextElementSibling;
            if (!nextSibling) {
                parent.nativeElement.appendChild(currentElement);
            }
            else {
                parent.nativeElement.insertBefore(currentElement, nextSibling);
            }
        }
        parent.children = parent.children.filter(it => it !== this);
        parent.children.splice(newIndex, 0, this);
        this.page.schemaChanged();
    }
}
//# sourceMappingURL=page-base-node.js.map