import { NodeType } from "../models/page-node.model";
import { PageBaseNode } from "./page-base-node";
import { SystemAttributes } from "../constants";
import { ElementAttributes } from "../element-attributes";
// import { cloneDeep } from "lodash";
export class PageCustomNode extends PageBaseNode {
    constructor(schema, page, parentElement) {
        super();
        this.nodeType = NodeType.custom;
        this.page = page;
        this.parentElement = parentElement;
        this.schema = schema;
        this.attributes = new ElementAttributes(this);
        this.createCustomNode();
    }
    createCustomNode() {
        const nodeTag = this.schema.tag.split('_')[1];
        if (!nodeTag) {
            console.warn('Page custom node tag was not specified');
            return;
        }
        super.createNode();
        const elRef = this.page.customElementFactory(this);
        this.nativeElement = elRef;
        this.hostElement = elRef;
        this.parentElement?.nativeElement?.appendChild(this.nativeElement);
        this.attributes.add({ name: SystemAttributes.nodeKey, value: this.key });
        this.nativeElement.setAttribute(SystemAttributes.nodeKey, this.key);
        this.nativeElement.tabIndex = 1;
        this.nativeElement.style.display = 'block';
        this.page.nodeCreated(this);
    }
    updateSchema(schema) {
        this.schema = schema;
        this.page.schemaChanged();
    }
}
//# sourceMappingURL=page-custom-node.js.map