import { IPageElementNode, NodeType, PageNode } from "../models/page-node.model";
import { PageBaseNode } from "./page-base-node";
import { Page } from "../page";
import { IPage } from "../models/page.model";
import { ElementClassList } from "../element-classlist";
import { ElementStyles } from "../element-styles";
import { PageElementNodeSchema, PageNodeSchema } from "../models/element-schema.model";
export declare class PageElementNode extends PageBaseNode<PageElementNode> implements IPageElementNode {
    nativeElement: HTMLElement;
    nodeType: NodeType;
    children: PageNode[];
    get childElements(): PageElementNode[];
    page: Page;
    schema: PageElementNodeSchema;
    hostElement: HTMLElement;
    parentElement: PageElementNode;
    classList: ElementClassList;
    styles: ElementStyles;
    constructor(schema: PageNodeSchema, page: IPage, parentElement?: IPageElementNode | undefined);
    private createElementNode;
    getSchema(): PageNodeSchema;
    findElement(predicate: (el: PageNode) => boolean): PageNode | undefined;
    destroy(): void;
    insertChild(schema: PageNodeSchema, emitSchemaChanged?: boolean): PageNode;
    insertHTMLFragment(fragment: string): PageNode[];
}
