import { StyleBase } from "./style-base";
import { StyleType } from "../models/style.model";
export class CustomStyle extends StyleBase {
    constructor(element) {
        super();
        this.element = element;
        this.styleType = StyleType.custom;
        this.selector = `${this.styleType}-${this.element.key}`;
        this.styleSheet = this.element.page.getStyleSheet();
    }
    get(property) {
        return this.rule.getProp(property);
    }
    getAll() {
        return this.rule.getAllProps();
    }
    append(property, value, apply = true) {
        this.rule.setProp(property, value);
        this.tryToApplyStyleRule(apply);
    }
    delete(property, apply = true) {
        this.rule.deleteProp(property);
        this.tryToApplyStyleRule(apply);
    }
    attach(key) {
        this.rule.attachProp(key);
        super.applyStyles();
    }
    detach(key) {
        this.rule.detachProp(key);
        super.applyStyles();
    }
    detached(key) {
        return this.rule.detached(key);
    }
}
//# sourceMappingURL=custom-style.js.map