import { StyleType } from "../models/style.model";
import { ElementEdges } from "../models/element-edges.model";
import { PageElementNode } from "../nodes/page-element-node";
import { StyleBase } from "./style-base";
export type Position = 'start' | 'center' | 'end' | 'space-between';
export type ItemsPosition = {
    direction: PositionDirection;
    x: Position;
    y: Position;
    gap?: string;
};
export type PositionDirection = 'row' | 'column';
export interface ILayoutStyle {
    backgroundColor?: string;
    margin?: ElementEdges<string> | string;
    padding?: ElementEdges<string> | string;
    position?: ItemsPosition;
}
export declare class LayoutStyle extends StyleBase<ILayoutStyle> {
    element: PageElementNode;
    styleType: StyleType;
    styleSheet: CSSStyleSheet;
    selector: string;
    constructor(element: PageElementNode);
    setPosition({ direction, x, y, gap }: ItemsPosition, apply?: boolean): void;
    getPosition(): ItemsPosition | undefined;
    deletePosition(apply?: boolean): void;
    setPadding(padding: ElementEdges<string> | string, apply?: boolean): void;
    getPadding(): ElementEdges<string> | string | undefined;
    deletePadding(apply?: boolean): void;
    setMargin(margin: ElementEdges<string> | string, apply?: boolean): void;
    getMargin(): ElementEdges<string> | string | undefined;
    deleteMargin(apply?: boolean): void;
    setBackgroundColor(color: string, apply?: boolean): void;
    getBackgroundColor(): string | undefined;
    deleteBackgroundColor(apply?: boolean): void;
}
