import { StyleType } from "../models/style.model";
import { StyleBase } from "./style-base";
export class SizeStyle extends StyleBase {
    constructor(element) {
        super();
        this.element = element;
        this.styleType = StyleType.size;
        this.selector = `${this.styleType}-${this.element.key}`;
        this.styleSheet = this.element.page.getStyleSheet();
    }
    setHeight(height, apply = true) {
        this.rule.setProp('height', height);
        this.tryToApplyStyleRule(apply);
    }
    getHeight() {
        return this.rule.getProp('height');
    }
    deleteHeight(apply = true) {
        this.rule.deleteProp('height');
        this.tryToApplyStyleRule(apply);
    }
    setWidth(width, apply = true) {
        this.rule.setProp('width', width);
        this.tryToApplyStyleRule(apply);
    }
    getWidth() {
        return this.rule.getProp('width');
    }
    deleteWidth(apply = true) {
        this.rule.deleteProp('width');
        this.tryToApplyStyleRule(apply);
    }
}
//# sourceMappingURL=size-style.js.map