import { StyleType } from "../models/style.model";
import { BorderStyle } from "./border-style";
import { BoxShadowStyle } from "./box-shadow-style";
import { CustomStyle } from "./custom-style";
import { LayoutStyle } from "./layout-style";
import { TextStyle } from "./text-style";
import { BackgroundBlurStyle } from "./background-blur.style";
import { LayerBlurStyle } from "./layer-blur.style";
import { SizeStyle } from "./size-style";
export function styleFactory(element, key) {
    switch (key) {
        case StyleType.border:
            return new BorderStyle(element);
        case StyleType.layout:
            return new LayoutStyle(element);
        case StyleType.text:
            return new TextStyle(element);
        case StyleType.boxShadow:
            return new BoxShadowStyle(element);
        case StyleType.backgroundBlur:
            return new BackgroundBlurStyle(element);
        case StyleType.layerBlur:
            return new LayerBlurStyle(element);
        case StyleType.size:
            return new SizeStyle(element);
        case StyleType.custom:
            return new CustomStyle(element);
        default:
            return undefined;
    }
}
//# sourceMappingURL=style-factory.js.map