import { ElementEdges } from "../models/element-edges.model";
interface PropEdgesOptions<T> {
    edgeKeys?: (keyof T)[];
    getEdgePropKey: (edgeKey: keyof T) => string;
}
export declare class StyleRule {
    private rule;
    private detachedProps;
    getAllProps(): Record<string, unknown>;
    setProp<T = string>(key: string, value: T): void;
    getProp<T = string>(key: string): T | undefined;
    getPropOrPropEdges<T = ElementEdges<string>, R = string>(key: string, options?: PropEdgesOptions<T>): T | R | undefined;
    getPropEdges<T = ElementEdges<string>>(key: string, options?: PropEdgesOptions<T>): T | undefined;
    setPropOrPropEdges<T = ElementEdges<string>, R = string>(key: string, value: T | R, options?: PropEdgesOptions<T>): void;
    setPropEdges<T = ElementEdges<string>>(key: string, value: T, options?: PropEdgesOptions<T>): void;
    attachProp(key: string): void;
    detachProp(key: string): void;
    detached(key: string): boolean;
    init(rule: Record<string, string>): void;
    deleteProp(key: string): void;
    deletePropEdges<T>(key: string, options?: PropEdgesOptions<T>): void;
    entries(): [string, unknown][];
    generateRuleText(): string;
}
export {};
