import { StyleType } from "../models/style.model";
import { PageElementNode } from "../nodes/page-element-node";
import { StyleBase } from "./style-base";
export type TextAlignment = 'left' | 'center' | 'right';
export type TextDecoration = 'line-through' | 'overline' | 'underline';
export declare class TextStyle extends StyleBase {
    element: PageElementNode;
    styleType: StyleType;
    styleSheet: CSSStyleSheet;
    selector: string;
    constructor(element: PageElementNode);
    getColor(): string | undefined;
    setColor(color: string, apply?: boolean): void;
    getLineHeight(): string | undefined;
    setLineHeight(lineHeight: string, apply?: boolean): void;
    getAlignment(): TextAlignment | undefined;
    setAlignment(alignment: TextAlignment, apply?: boolean): void;
    getFontSize(): string | undefined;
    setFontSize(fontSize: string, apply?: boolean): void;
    getDecoration(): TextDecoration | undefined;
    setDecoration(decoration: TextDecoration, apply?: boolean): void;
    private setDefaults;
}
