import { StyleType } from "../models/style.model";
import { StyleBase } from "./style-base";
export class TextStyle extends StyleBase {
    constructor(element) {
        super();
        this.element = element;
        this.styleType = StyleType.text;
        this.selector = `${this.styleType}-${this.element.key}`;
        this.styleSheet = this.element.page.getStyleSheet();
        this.setDefaults();
    }
    getColor() {
        return this.rule.getProp('color');
    }
    setColor(color, apply = true) {
        this.rule.setProp('color', color);
        this.tryToApplyStyleRule(apply);
    }
    getLineHeight() {
        return this.rule.getProp('line-height');
    }
    setLineHeight(lineHeight, apply = true) {
        this.rule.setProp('line-height', lineHeight);
        this.tryToApplyStyleRule(apply);
    }
    getAlignment() {
        return this.rule.getProp('text-align');
    }
    setAlignment(alignment, apply = true) {
        this.rule.setProp('text-align', alignment);
        this.tryToApplyStyleRule(apply);
    }
    getFontSize() {
        return this.rule.getProp('font-size');
    }
    setFontSize(fontSize, apply = true) {
        this.rule.setProp('font-size', fontSize);
        this.tryToApplyStyleRule(apply);
    }
    getDecoration() {
        return this.rule.getProp('text-decoration');
    }
    setDecoration(decoration, apply = true) {
        this.rule.setProp('text-decoration', decoration);
        this.tryToApplyStyleRule(apply);
    }
    setDefaults() {
        this.rule.setProp('color', '#000000');
        this.rule.setProp('line-height', 'auto');
        this.rule.setProp('text-align', 'left');
    }
}
//# sourceMappingURL=text-style.js.map